public class UpTree {

    private UpTree parent;
    private int data;

    /**
     *  Creates new uptree with a null parent and given data.
     *  @param data   Data of this node.
     */
    public UpTree(int data) {
        this.data = data;
    }

    /**
     *  Accessor that sets the parent of this uptree.
     *  @param parent  Uptree that will become the parent.
     */
    public UpTree getParent() {
        return parent;
    }

    /**
     *  Accessor that sets the parent of this uptree.
     *  @param parent  Uptree that will become the parent.
     */
    public void setParent(UpTree parent) {
        this.parent = parent;
    }

    /**
     *  Prints out the data associated with this uptree, plus
     *  prints its parents recursively.
     */
    public void printMe() {
        if (parent != null) {
            System.out.print(data + " parent = ");
            parent.printMe();
        }
        else System.out.println(data);
    }

}
